## org.apache.fop.fo
Class FObj

    java.lang.Object
      |
      +--org.apache.fop.fo.FONode
            |
            +--org.apache.fop.fo.FObj

Direct Known Subclasses:
  BlockContainer, Character, ConditionalPageMasterReference, DisplaySequence, ExtensionObj, ExternalGraphic, Flow, FObjMixed, Footnote, FootnoteBody, InlineGraphic, InstreamForeignObject, LayoutMasterSet, ListBlock, ListItem, ListItemBody, ListItemLabel, PageMasterReference, PageNumber, PageNumberCitation, PageSequence, PageSequenceMaster, Region, RepeatablePageMasterAlternatives, Root, SimplePageMaster, SVG, SVGObj, Table, TableBody, TableCell, TableColumn, TableRow

public class FObj
extends FONode

base class for representation of formatting objects and their processing

Inner Class Summary
`static class` `FObj.Maker`

Field Summary
`protected java.lang.String` `name`
`PropertyList` `properties`

Fields inherited from class org.apache.fop.fo.FONode
`bodyIndent, BREAK_AFTER, children, distanceBetweenStarts, forcedStartOffset, forcedWidth, isInLabel, isInListBody, isInTableCell, labelSeparation, linkSet, marker, orphans, parent, START, widows`

Constructor Summary
`protected` `FObj(FObj parent, PropertyList propertyList)`

Method Summary
`protected void` `addCharacters(char[] data, int start, int length)` adds characters (does nothing here)
`protected void` `end()`
`boolean` `generatesReferenceAreas()`
`int` `getContentWidth()` Return the "content width" of the areas generated by this FO.
`java.lang.String` `getName()` returns the name of the formatting object
`Property` `getProperty(java.lang.String name)` lets outside sources access the property list first used by PageNumberCitation to find the "id" property
`Status` `layout(Area area)` generates the area or areas for this formatting object and adds these to the area.
`static FObj.Maker` `maker()`
`void` `removeID(IDReferences idReferences)` removes property id
`protected void` `start()`

Methods inherited from class org.apache.fop.fo.FONode
`addChild, forceStartOffset, forceWidth, getLinkSet, getMarkerSnapshot, getParent, removeAreas, resetMarker, rollback, setBodyIndent, setDistanceBetweenStarts, setIsInLabel, setIsInListBody, setIsInTableCell, setLabelSeparation, setLinkSet, setOrphans, setWidows`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### properties

    public PropertyList properties

### name

    protected java.lang.String name

Constructor Detail

### FObj

    protected FObj(FObj parent,
                   PropertyList propertyList)

Method Detail

### maker

    public static FObj.Maker maker()

### addCharacters

    protected void addCharacters(char[] data,
                                 int start,
                                 int length)

  adds characters (does nothing here)
  Parameters:
    `data` - text
    `start` - start position
    `length` - length of the text

### layout

    public Status layout(Area area)
                  throws FOPException

  generates the area or areas for this formatting object and adds these to the area. This method should always be overridden by all sub classes
  Overrides:
    layout in class FONode
  Parameters:
    `area` -

### getName

    public java.lang.String getName()

  returns the name of the formatting object
  Returns:
    the name of this formatting objects

### start

    protected void start()

### end

    protected void end()

### getProperty

    public Property getProperty(java.lang.String name)

  lets outside sources access the property list first used by PageNumberCitation to find the "id" property
  Overrides:
    getProperty in class FONode
  Parameters:
    `name` - - the name of the desired property to obtain
  Returns:
    the property

### getContentWidth

    public int getContentWidth()

  Return the "content width" of the areas generated by this FO. This is used by percent-based properties to get the dimension of the containing block. If an FO has a property with a percentage value, that value is usually calculated on the basis of the corresponding dimension of the area which contains areas generated by the FO. NOTE: subclasses of FObj should implement this to return a reasonable value!

### removeID

    public void removeID(IDReferences idReferences)

  removes property id
  Parameters:
    `idReferences` - the id to remove

### generatesReferenceAreas

    public boolean generatesReferenceAreas()

Copyright © 1999-2001 Apache Software Foundation. All Rights Reserved.